<?php
/**
* @version      2.4.0 15.10.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

include_once(JPATH_ROOT . "/components/com_jshopping/lib/jtableauto.php");
include_once(JPATH_ROOT . "/components/com_jshopping/lib/multilangfield.php");
include_once(JPATH_ROOT . "/components/com_jshopping/tables/config.php");

class JSFactory{
    
    function &getConfig(){
    static $config;
        if (!is_object($config)){                                   
                        
            $db = &JFactory::getDBO();
            $config = new jshopConfig($db);
            $config->load("1");                     
            
            $params = JComponentHelper::getParams('com_languages');
            $frontend_lang = $params->get('site','en-GB');
            $config->frontend_lang = $frontend_lang;
            
            $lang = &JFactory::getLanguage();
            $config->cur_lang = $lang->getTag();
            
            $config->path = JPATH_ROOT . "/components/com_jshopping/";
            $config->admin_path = JPATH_ROOT . '/administrator/components/com_jshopping/';
            
            $config->live_path = JURI::root() . 'components/com_jshopping/';
            $config->live_admin_path = JURI::root() . 'administrator/components/com_jshopping/';
            
            $config->log_path = JPATH_ROOT . "/components/com_jshopping/log/";
            
            $config->importexport_live_path = $config->live_path . "files/importexport/";
            $config->importexport_path = $config->path . "files/importexport/";

            $config->image_category_live_path = $config->live_path . $config->image_category_path;
            $config->image_category_path = $config->path . $config->image_category_path;

            $config->image_product_live_path = $config->live_path . $config->image_product_path;
            $config->image_product_path = $config->path . $config->image_product_path;
            
            $config->image_manufs_live_path = $config->live_path . $config->image_manufs_path;
            $config->image_manufs_path = $config->path . $config->image_manufs_path;

            $config->video_product_live_path = $config->live_path . $config->video_product_path;
            $config->video_product_path = $config->path . $config->video_product_path;
                        
            $config->demo_product_live_path = $config->live_path. "files/demo_products";
            $config->demo_product_path = $config->path . "files/demo_products";
            
            $config->files_product_live_path = $config->live_path. "files/files_products";
            $config->files_product_path = $config->path . "files/files_products";
            
            $config->pdf_orders_live_path = $config->live_path . "files/pdf_orders";
            $config->pdf_orders_path = $config->path . "files/pdf_orders";
            
            $config->image_attributes_live_path = $config->live_path . "files/img_attributes";
            $config->image_attributes_path = $config->path . "files/img_attributes";            
                        
            $config->thousand_separator = (!$config->thousand_separator)?(" "):($config->thousand_separator);
            
            list($config->pdf_header_width, $config->pdf_header_height, $config->pdf_footer_width, $config->pdf_footer_height) = explode(":", $config->pdf_parameters);
            $config->pdf_header_width = ($config->pdf_header_width > 208) ? (208) : (intval($config->pdf_header_width));
            $config->pdf_footer_width = ($config->pdf_footer_width > 208) ? (208) : (intval($config->pdf_footer_width));
            
            $config->arr['title'] = array(0=>_JSHOP_REG_SELECT, 1=>_JSHOP_MR, 2=>_JSHOP_MS);
            $config->sorting_products_field_select = array(1 => 'name', 2=>'prod.product_price', 3=>'prod.product_date_added', 4=>'categ.product_ordering');
            $config->sorting_products_name_select =  array(1=>_JSHOP_ALPH, 2=>_JSHOP_PRICE, 3=>_JSHOP_DATA, 4=>_JSHOP_SORT);            
            $config->sorting_products_field_s_select = array(1 => 'name', 2=>'prod.product_price', 3=>'prod.product_date_added');
            $config->sorting_products_name_s_select =  array(1=>_JSHOP_ALPH, 2=>_JSHOP_PRICE, 3=>_JSHOP_DATA);
            $config->format_currency = array('1' => '00Symb', '00 Symb', 'Symb00', 'Symb 00');
            $config->count_product_select = array('5'=>5, '10' => 10, '15' => 15, '20' => 20, '25' => 25, '50' => 50);
                        
            $config->payment_status_enable_download_sale_file = array(2, 5, 6); 
            $config->max_number_download_sale_file = 3; 
                
            $config->product_price_qty_discount = 2; // (1 - price, 2 - percent)
            $config->rating_starparts = 2; //star is divided to {2} part
            
            if ($config->user_as_catalog){
                $config->show_buy_in_category = 0;
            }
            
            if ($config->hide_product_not_avaible_stock || $config->hide_buy_not_avaible_stock){
                $config->controler_buy_qty = 1;
            }else{
                $config->controler_buy_qty = 0;
            }
            
            $config->use_simple_sef = 0;
            
            $config->savelog = 0; //1 - for develop
        }
    return $config;
    }
    
    function &getUserShop(){
    static $usershop;
        if (!is_object($usershop)){
            $user = &JFactory::getUser();
            $db = &JFactory::getDBO();
            require_once(JPATH_ROOT . "/components/com_jshopping/tables/usershop.php");
            $usershop = new jshopUserShop($db);
            if($user->id){
                if(!$usershop->isUserInShop($user->id)) {
                    $usershop->addUserToTableShop($user);
                }                
                $usershop->load($user->id);
                $usershop->percent_discount = $usershop->getDiscount();
            }else{
                $usershop->percent_discount = 0;
            }
        }
    return $usershop;    
    }
    
    function &getUserShopGuest(){
    static $userguest;
        if (!is_object($userguest)){
            require_once(JPATH_ROOT . "/components/com_jshopping/models/userguest.php");
            $userguest = new jshopUserGust();
            $userguest->load();
            $userguest->percent_discount = 0;
        }
    return $userguest;
    }
    
    function loadCssFiles(){
    static $load;
        if (!$load){
            $document =& JFactory::getDocument();
            $document->addCustomTag('<link type = "text/css" rel = "stylesheet" href = "'.JURI::root().'components/com_jshopping/css/style.css" />');
            $load = 1;
        }
    }
    
    function loadJsFiles(){
    static $load;
        if (!$load){
            $document =& JFactory::getDocument();
            $document->addCustomTag('<script type = "text/javascript" src = "'.JURI::root().'components/com_jshopping/js/jquery/jquery-1.3.2.min.js"></script>');
            $document->addCustomTag('<script type = "text/javascript">jQuery.noConflict();</script>');
            $document->addCustomTag('<script type = "text/javascript" src = "'.JURI::root().'components/com_jshopping/js/jquery/jquery.media.js"></script>');
            $document->addCustomTag('<script type = "text/javascript" src = "'.JURI::root().'components/com_jshopping/js/functions.js"></script>');
            $document->addCustomTag('<script type = "text/javascript" src = "'.JURI::root().'components/com_jshopping/js/validateForm.js"></script>');
            $load = 1;
        }
    }
    
    function loadJsFilesRating(){
    static $load;
        if (!$load){
            $document =& JFactory::getDocument();
            $document->addCustomTag('<script type = "text/javascript" src = "'.JURI::root().'components/com_jshopping/js/jquery/jquery.MetaData.js"></script>');
            $document->addCustomTag('<script type = "text/javascript" src = "'.JURI::root().'components/com_jshopping/js/jquery/jquery.rating.pack.js"></script>');            
            $document->addCustomTag('<link type = "text/css" rel = "stylesheet" href = "'.JURI::root().'components/com_jshopping/css/jquery.rating.css" />');      
            $load = 1;
        }
    }
    
    function loadLanguageFile(){
        $lang = &JFactory::getLanguage();
        if(file_exists(JPATH_ROOT . '/components/com_jshopping/lang/' . $lang->getTag() . '.php')) 
            require_once (JPATH_ROOT . '/components/com_jshopping/lang/' . $lang->getTag() . '.php'); 
        else 
            require_once (JPATH_ROOT . '/components/com_jshopping/lang/en-GB.php');
    }
       
    function &getLang(){
    static $ml;
        if (!is_object($ml)){
            $jshopConfig = &JSFactory::getConfig();
            $ml = new multiLangField();
            $ml->setLang($jshopConfig->cur_lang);
        }
    return $ml;
    }
    
    function &getReservedFirstAlias(){
    static $alias;
        if (!is_array($alias)){
            $alias = array("category","manufacturer","cart","content","importexport","checkout","product","search","user","wishlist");
        }
    return $alias;
    }
    
    function &getAliasCategory(){
    static $alias;
        if (!is_array($alias)){            
            $db = &JFactory::getDBO();
            $lang = &JSFactory::getLang();            
            $dbquery = "select category_id as id, `".$lang->get('alias')."` as alias from #__jshopping_categories where `".$lang->get('alias')."`!=''"; 
            $db->setQuery($dbquery);
            $rows = $db->loadObjectList();
            $alias = array();
            foreach($rows as $row){
                $alias[$row->id] = $row->alias;
            }
            unset($rows);
        }
    return $alias;
    }
    
    function &getAliasManufacturer(){
    static $alias;
        if (!is_array($alias)){            
            $db = &JFactory::getDBO();
            $lang = &JSFactory::getLang();            
            $dbquery = "select manufacturer_id as id, `".$lang->get('alias')."` as alias from #__jshopping_manufacturers where `".$lang->get('alias')."`!=''";
            $db->setQuery($dbquery);
            $rows = $db->loadObjectList();
            $alias = array();
            foreach($rows as $row){
                $alias[$row->id] = $row->alias;
            }
            unset($rows);
        }
    return $alias;
    }
    
    function &getAliasProduct(){
    static $alias;
        if (!is_array($alias)){            
            $db = &JFactory::getDBO();
            $lang = &JSFactory::getLang();            
            $dbquery = "select product_id as id, `".$lang->get('alias')."` as alias from #__jshopping_products where `".$lang->get('alias')."`!=''"; 
            $db->setQuery($dbquery);
            $rows = $db->loadObjectList();
            $alias = array();
            foreach($rows as $row){
                $alias[$row->id] = $row->alias;
            }
            unset($rows);
        }
    return $alias;
    }           
    
}

?>